app.controller('ChatDetailsCtrl', function($scope, $timeout, $rootScope, $ionicScrollDelegate, message, $stateParams, $ionicModal, $cordovaToast, connnection, $state) {

   $scope.token = localStorage.getItem("token");
   $scope.loginuserId = localStorage.getItem("loginuserId");
   $scope.loginchatUserid = localStorage.getItem("chatUserid");
   $scope.page = 1;

             

             $scope.$on("$ionicView.beforeEnter", function(event, data){
                   $scope.getConvesation();
              })


     $timeout(function() { 
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom();               
     }, 100);

   $scope.messages = [];

//////////////GET CHAT HISTORY FORM APP SERVER/////////////////

    $scope.getConvesation = function(){
        $scope.show();
        message.live_chatDetails($scope.token,  $stateParams.userid).then(function(response){
            $scope.hide();
            if(response.data.list){
                $scope.messages = response.data.list;
            }
            console.log("conversationList:", response)

            $rootScope.conv_id = response.data.thread_id;

            //console.log("message:", response)
            console.log("currentCnvId :", $rootScope.conv_id);

            $scope.otheruserName = response.data.partner.firstname; 
            $scope.otheruserPic = response.data.partner.profile_pic;

            $timeout(function() { 
            $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom();               
            }, 100);

         })
    }

   $scope.inputUp = function () {
          if (isIOS)
              $scope.data.keyboardHeight = 216;
          $timeout(function () {
              $ionicScrollDelegate.scrollBottom(true);
          }, 300);

      };

      $scope.inputDown = function () {
          if (isIOS)
              $scope.data.keyboardHeight = 0;
          $ionicScrollDelegate.resize();
      };


  // $scope.infiniteScrollActive = true;
  // $scope.loadMore = function() {
  //   $scope.infiniteScrollActive = false;
  //   $scope.page++
  //   $scope.getConvesation();
  //   $scope.$broadcast('scroll.infiniteScrollComplete');
  // }

/////////////Create new dialog///////////////////////



$scope.createDialog = function(){

  if(!$scope.data.message){
    $cordovaToast.showLongBottom("Message empty!");

  }else{



  var d = new Date();
    //Adding the message to UI
    $scope.messages.push({
      userId:  $scope.loginchatUserid,
      content: $scope.data.message,
      createdAt: d
    });

    //Adding the message to BOF SERVER
    message.send_message($scope.token, $scope.data.message, $stateParams.userid,  $rootScope.conv_id).then(function(response){

      if(response.data.conversationId !=undefined){
        $rootScope.conv_id = response.data.conversationId;
      }
      console.log("resConverid : ", $rootScope.conv_id)
    })

    $ionicScrollDelegate.scrollBottom(true);


    //Send the message to Quickblox
    var occupants_ids = [];
    occupants_ids.push($stateParams.chatid);
    var params = { type: 3, occupants_ids};

    QB.chat.dialog.create(params, function(err, createdDialog) {
      if (err) {
        console.log(err);
      } else {

        notifyOccupants(createdDialog.occupants_ids, createdDialog._id);


        console.log("createdDialog._id", createdDialog._id);

        $scope.dialogId = createdDialog._id;


        function notifyOccupants(dialogOccupants, newDialogId) {
          dialogOccupants.forEach(function(itemOccupanId, i, arr) {
            if (itemOccupanId !=  $scope.loginchatUserid) {
             console.log("itemOccupanId", itemOccupanId, "loginchatUserid",  $scope.loginchatUserid )
             var msg = {
               type: 'chat',
               body: $scope.data.message,
               extension: {
                save_to_history: 1,
                _id: newDialogId,
              }, 
            };

            var message = {
            body: $scope.data.message, 
            extension: {
            name: $rootScope.username,
            param2: "value2"
            }
            };
            
            QB.chat.send(itemOccupanId, msg);

            QB.chat.sendSystemMessage(itemOccupanId, message);
            delete $scope.data.message;
          }

        });

        }
      }
    });

  //Send the message to Quickblox
   }
  }


// $scope.sendTypingStatus = function() {     
//   if ($scope.data.message.length == 3) {
//     console.log("typestatus sent")
//     QB.chat.sendIsTypingStatus($scope.dialogId);
//   }
// }



// QB.chat.onMessageTypingListener  = function(isTyping, userId, dialogId) {
//    console.log("isTyping", isTyping, userId );
// };

// function onMessageTyping(isTyping, userId, dialogId) {
//    console.log("isTyping", isTyping, userId );
 
// }

QB.chat.onContactListListener = function(userId, type) {
    console.log("online user::=>", userId, "type", type);
};

// onMessageListener///////////
QB.chat.onMessageListener = onMessage;

function onMessage(userId, msg) {
  console.log("onMessageListener msg:", msg, "userId:", userId);
   var d = new Date();
   $timeout(function() {

      console.log("userId", userId, "$stateParams.chatid", $stateParams.chatid)

      if(userId == $stateParams.chatid){
          $scope.messages.push({
          userId: userId,
          content: msg.body,
          createdAt: d,
          });
      }

        $ionicScrollDelegate.scrollBottom(true);
   }, 10);
}







});