angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope,$ionicPlatform, $ionicPopup, Profile, $cordovaToast, $rootScope, $cordovaGeolocation, $controller, $ionicModal, $timeout, $ionicLoading, $state) {

      $scope.hideNavBar = function () {
        document.getElementsByTagName('ion-nav-bar')[0].style.display = 'none';
    };

    $scope.showNavBar = function () {
        document.getElementsByTagName('ion-nav-bar')[0].style.display = 'block';
    };

    $scope.noHeader = function () {
        var content = document.getElementsByTagName('ion-content');
        for (var i = 0; i < content.length; i++) {
            if (content[i].classList.contains('has-header')) {
                content[i].classList.toggle('has-header');
            }
        }
    };


    $scope.hasHeader = function () {
        var content = document.getElementsByTagName('ion-content');
        for (var i = 0; i < content.length; i++) {
            if (!content[i].classList.contains('has-header')) {
                content[i].classList.toggle('has-header');
            }
        }

    };

    $scope.hideHeader=function(){
        $scope.hideNavBar();
        $scope.noHeader();
        
    }
    $scope.showHeader=function(){
        $scope.showNavBar();
        $scope.hasHeader();
    }

    $scope.show = function () {
        $ionicLoading.show({
        template: '<ion-spinner icon="bubbles"></ion-spinner>'
        });
    };
    $scope.hide = function () {
        $ionicLoading.hide();
    };




    ///////////PUSH LOCATION



    $scope.$on('cloud:push:notification', function (event, data) {

       // console.log("msg", data.message.payload.type);
        // $state.go('app.notification');

        // if(data.message.payload.type == "message"){
        //    $state.go('app.chat');
        // }else if(data.message.payload.type == "connection_request"){
        //    $state.go('app.connection_screen');
        //  }else if(data.message.payload.type == "response_to_connection_requrst"){
        //      $state.go('app.connection_screen');
        //  }else if(data.message.payload.type == "interestinmeeting"){
        //      $state.go('app.meetingyou');
        //  }else{
        //      $state.go('app.home_screen');
        //  }
    });






  //Extend Serach CTRL

  //$controller('searchCtrl', { $scope: $scope });

  $scope.searchArea = function(){
     if($state.current.name=="app.search"){
        
     }else{
      console.log("false")
       $state.go('app.search');
     }
  }


  $rootScope.receiveuser = {};

  ////CHANGE PASSWORD ////////////////

        $scope.change_pass = function() {

          

          var confirmPopup = $ionicPopup.confirm({
             title: 'Change Password',
             templateUrl: 'templates/change_pass.html'
          });

          confirmPopup.then(function(res) {
             if(res == false){

             }else{
              var password = document.changepass.password.value;
              var confirm_password = document.changepass.confirmpassword.value;
              var oldpass = localStorage.getItem("password");

              if(password == ''){
                 $cordovaToast.showLongBottom('Please enter password');
              }
              else if(confirm_password == ''){
                 $cordovaToast.showLongBottom('Please re-enter password');
              }else if(confirm_password != password){
                 $cordovaToast.showLongBottom('Password does not match');
              }
              else if(confirm_password.length <6){
                  $cordovaToast.showLongBottom('Password length should be minimum 6 characters');
              }else{ 
                  var tokenid =  localStorage.getItem("token");
                 Profile.changePassword(tokenid,password).then(function(response){

              
                 console.log(response);
                  if(response.data.success == true){
                    $cordovaToast.showLongBottom('Password changed successfully');
                  }
                })
              }
             }
              
              
             });
         };


   ////Get GEO LOCATION///

   $scope.$on("$ionicView.enter", function(event, data){
        $scope.token = localStorage.getItem("token");
        $scope.loginuserId = localStorage.getItem("loginuserId");

        console.log("userid", $scope.loginuserId )

        if($state.current.name=="app.home_screen") {

            $scope.GetProfileDetails();

        }

      })

       $scope.GetProfileDetails = function(){
        console.log($scope.token,$scope.loginuserId )
          Profile.getProfiledetails($scope.token, $scope.loginuserId).then(function(response){

              if(response.data.success == true){
                  //console.log("getdetaus:", response);
                  $rootScope.username = response.data.data.firstname;
                  $rootScope.userpic = response.data.data.profile_pic;
              }else{
                console.log("getdetaus:", response);
              }
                
                 
               })
          }


 ////////////////SUBSCRIBE MODAL//////////////////
 
  $ionicModal.fromTemplateUrl('templates/subscribe_modal.html', {
      scope: $scope,
      animation: 'slide-in-up',
      }).then(function(modal) {
      $scope.subscribemodal = modal;
  });

  $scope.closeSebmodal = function(){
    document.body.classList.remove('modal-open');
    $scope.subscribemodal.hide();
    $scope.call_modal.hide();
    
  }

    $ionicModal.fromTemplateUrl('templates/call_modal.html', {
      scope: $scope,
      animation: 'slide-in-up',
      }).then(function(modal) {
      $scope.call_modal = modal;
  });



  
//////CHAT CREDENTIAL///////////////////////


var CONFIG = {
  //debug: true,
  webrtc: {
    answerTimeInterval: 60, // Max answer time after that the 'QB.webrtc.onUserNotAnswerListener' callback will be fired.
    dialingTimeInterval: 5,  // The interval between call requests produced by session.call(extension)
    disconnectTimeInterval: 30, // If an opponent lost a connection then after this time the caller will now about it via 'QB.webrtc.onSessionConnectionStateChangedListener' callback.
    statsReportTimeInterval: true, // Allows access to the statistical information about a peer connection. You can set amount of seconds you can get statistic information after.
    iceServers: [
      {
        'url': 'stun:stun.l.google.com:19302'
      },
      {
        'url': 'stun:turn.quickblox.com',
        'username': 'quickblox',
        'credential': 'baccb97ba2d92d71e26eb9886da5f1e0'
      },
      {
        'url': 'turn:turn.quickblox.com:3478?transport=udp',
        'username': 'quickblox',
        'credential': 'baccb97ba2d92d71e26eb9886da5f1e0'
      },
      {
        'url': 'turn:turn.quickblox.com:3478?transport=tcp',
        'username': 'quickblox',
        'credential': 'baccb97ba2d92d71e26eb9886da5f1e0'
      },
    ]
  }
};

var QBApp = {
  appId: 55643,
  authKey: 'Q8H9CgWW2gcSwXq',
  authSecret: 'ed6Yc3n87-BuFMZ',
  CONFIG: CONFIG
};

$rootScope.showCallEnd = false;

$scope.mediaParams = {
  'audio': true,
  'video': true,
  'options': {
      'muted': true,
      'mirror': false
  },
  'elemId': 'localVideo'
};

     QB.init(QBApp.appId, QBApp.authKey, QBApp.authSecret, QBApp.CONFIG);


//When user receiving the call
            QB.webrtc.onCallListener = function (remote_session, extension) {
                console.log("onCallListener > remote_session : ", remote_session, "extension", extension);
                
                  document.addEventListener('deviceready', function () {
                    cordova.plugins.notification.local.schedule({
                    title: "Best of friends",
                    text: "Incoming call",
                    sound: "file://sound/notification3.mp3",
                    icon: "http://162.243.110.92:3433/images/icon.png"
                  });


                  }, false);


                 $rootScope.callerName = extension.name;
                  document.getElementById('callingSignal').play();

                 $scope.call_modal.show();

                 $scope.acceptCall = function(){

                   $scope.closeSebmodal();

                    document.getElementById('callingSignal').pause();

                    $state.go('app.videochat');
                        /*var opponentIds = [];
                        opponentIds.push(remote_session.initiatorID);
                        var sessionType = QB.webrtc.CallType.VIDEO; // AUDIO is also possible
                        var session = QB.webrtc.createNewSession(opponentIds, sessionType);*/
                        
                        remote_session.getUserMedia($scope.mediaParams, function (err, stream) {

                            if (err) {
                                console.log("SESSION err:", err);
                            } else {
                                
                                //Show video on HTML
                                remote_session.attachMediaStream('localVideo', stream);
                              
                                $timeout(function(){
                                    remote_session.accept();
                                    $rootScope.showCallEnd = true;
                                });
                            }
                        });

                 }

                 $scope.rejectCall = function(){
                      console.log("incoming Cancel")
                      $state.go('app.chat');
                      $scope.closeSebmodal();
                       document.getElementById('callingSignal').pause();
                      remote_session.reject(extension);
                 }


                // // var confirmPopup = $ionicPopup.confirm({
                // //     title: 'Incoming call from '+ extension.name,
                // //     template: 'Are you sure you want to accept the call?',
                // //     cancelText: 'Reject', // String (default: 'Cancel'). The text of the Cancel button.
                // //     cancelType: 'button-danger', // String (default: 'button-default'). The type of the Cancel button.
                // //     okText: 'Accept', // String (default: 'OK'). The text of the OK button.
                // //     okType: 'button-positive', // String (default: 'button-positive'). The type of the OK button.
                // // });

                // confirmPopup.then(function (res) {
                //    //var extension = {};
                //     if (res) {
                //          console.log("incoming accept")
                       
                        
                //      }  else {
                //            console.log("incoming Cancel")
                //            remote_session.reject(extension);
                //      }
                // });
            };

//sender will receive When the receiver accepted the call
            QB.webrtc.onAcceptCallListener = function (session, userId, extension) {
                console.log("onAcceptCallListener > ");
                console.log('UserId: ', userId);
                console.log('Session: ', session);
                console.log('Extension: ', extension);
                document.getElementById('callingSignal').pause();
                $rootScope.showCallEnd = true;
            };

//sender will receive When the receiver rejected the incoming call
            QB.webrtc.onRejectCallListener = function (session, userId, extension) {
                console.log("onRejectCallListener > session : ", session, "\nuserId : ", userId);
                document.getElementById('callingSignal').pause();
                 $cordovaToast.showLongBottom("Call Rejected!");
                $scope.closeSebmodal();
                $state.go('app.chat');
               
            };

            QB.webrtc.onRemoteStreamListener = function (session, userID, remoteStream) {
                // attach the remote stream to DOM element
                console.log("onRemoteStreamListener > remoteStream: ", remoteStream);
                session.attachMediaStream('remoteVideo', remoteStream);
            };

//When there is no answer from receiver (or user is offline)
            QB.webrtc.onUserNotAnswerListener = function (session, userId) {
                console.log("onUserNotAnswerListener > session : ", session, "\nuserId : ", userId);
            };

//Other user will receive this when somebody ends the current call

          QB.webrtc.onCallStatsReport = function onCallStatsReport(session, userId, stats, error) {
          console.log("onCallStatsReport >: ", session);
               $rootScope.receiveuser = session;
          }

               QB.chat.onSystemMessageListener = function(receivedMessage){
                 console.log("AlertreceivedMessage", receivedMessage)

                 ////LOCAL CHAT NOTIFICATION

                  // document.addEventListener('deviceready', function () {
                  //   cordova.plugins.notification.local.schedule({
                  //    title: receivedMessage.extension.name,
                  //    text: receivedMessage.body,
                  //    sound: "file://sound/notification3.mp3",
                  //    icon: "http://162.243.110.92:3433/images/icon.png"
                  //   });

                  //   cordova.plugins.notification.local.on("click", function (notification) {
                  //         $state.go('app.chat');
                  //   });

                  //   }, false);

              
            
              }


  $scope.logout = function() {

   
      console.log("logout");
      localStorage.clear();
      $state.go('app.login_screen', {}, {reload: true});
        QB.chat.disconnect();
      
      QB.logout(function(err, result){
        if (result) {
           console.log("result", result);
        } else {
          // error
        }
      });

    


  }

/////////////////////USER AUTO LOGIN ALSO LOGIN IN QUICK BLOCX///////////////////////////////////

QB.chat.onDisconnectedListener = onDisconnectedListener;
QB.chat.onReconnectListener = onReconnectListener;
 
function onDisconnectedListener(){}
function onReconnectListener(){}

/////////////////////USER AUTO LOGIN ALSO LOGIN IN QUICK BLOCX///////////////////////////////////

    $scope.userIsLoggedIn = false;

    var tokenid = localStorage.getItem("token");
    var userid = localStorage.getItem("loginuserId");
    var password = localStorage.getItem("password");
    var email = localStorage.getItem("email");

   
    if (tokenid == "" || tokenid == null || tokenid == "null") {
        $scope.userIsLoggedIn = false;
        $state.go('app.login_screen', {}, {reload: true});
    } else {
        $scope.userIsLoggedIn = true;
        //sharedConn.login(userid,password);
        $state.go('app.home_screen', {}, {reload: true});

        QB.createSession({login: email, password: password}, function(err, res) {
          console.log("createSession > res: ", res);
        if (res) {
           localStorage.setItem("chatUserid", res.user_id); 
         QB.chat.connect({userId: res.user_id, password: password}, function(err, roster) {
            if (err) {
            console.log(err);
            } else {
                console.log("connect rester:", roster);
            }
        });
        }else{
          console.log(err);
          }
        });

   }

/////////////////////////USER AUTO LOGIN ALSO LOGIN IN QUICK BLOCX//////////////////////  

});

