
angular.module('starter.controllers', [])

app.controller('homeCtrl', function($scope, $ionicPopup, $rootScope, $cordovaToast, $state, $ionicModal,Profile, $controller, $timeout,$ionicSideMenuDelegate, $ionicHistory, $ionicPlatform, TDCardDelegate) {

    $scope.token = localStorage.getItem("token");
    $scope.loginuserId = localStorage.getItem("loginuserId");
    var password = localStorage.getItem("password");
    var email = localStorage.getItem("email");

    $scope.cardTypes = [];
    $scope.page = 1;


  //show_header
   $scope.$on("$ionicView.beforeEnter", function(event, data){

        $ionicHistory.nextViewOptions({
              disableBack: false
          });

    		$timeout(function() {
      		$ionicSideMenuDelegate.canDragContent(false);
          $scope.showHeader();
       
    		},100);

         $scope.getPlaninfo();

	})


    ///GET USER ACTIVE PLAN INFO///

  $scope.getPlaninfo = function(){

     Profile.getactiveplan($scope.token).then(function(response){
    // console.log("plan=>", response)
         $scope.subscribeplan = response.data.plans;
         if(response.data.activePlan == null){
              $rootScope.planActive = "inactive";
              $scope.subscribemodal.show();

               $rootScope.btnoff = true;
         }else{
           $rootScope.planActive = "active";
           if(response.data.activePlan.expire_in_days  < 7){
              $ionicPopup.alert({
                content: "Your subscription expire on <br/> "+response.data.activePlan.expire_date
              })
           }

         }

     }) 


  }

 


    //Get User LIST and card swipe

      $scope.getUserlist = function(page){
       $scope.show();
       Profile.getuserlist($scope.token, $scope.page).then(function(response){

        console.log("userlist response", response)

       // console.log("$scope.page", $scope.page)


       $scope.hide();

       $scope.totaluser = response.data.TotalUser;

       // console.log("$scope.dataLenght", $rootScope.dataLenght);

        for(var i=0;i<response.data.data.length;i++){
                if(response.data.data[i].isConnected == '1'){
                    $scope.connect = "false";
                }else{
                    $scope.connect = "true";
                }
                $scope.cardTypes.push(response.data.data[i]);
           }

        $scope.cards = {
          master: Array.prototype.slice.call($scope.cardTypes, 0),
          active: Array.prototype.slice.call($scope.cardTypes, 0),
          discards: [],
          liked: [],
          disliked: []
        }
         

        //console.log("$scope.cards : ", $scope.cards);
      })
    }

 $scope.getUserlist();




 $scope.currentIndex = 0;

  $scope.cardDestroyed = function(index) {
    $scope.cardTypes.splice(index, 1);
	   console.log(index);
  };

  $scope.addCard = function() {
    var newCard = cardTypes[0];
    $scope.cardTypes.push(angular.extend({}, newCard));
  }

  $scope.refreshCards = function() {

    // Set $scope.cards to null so that directive reloads
    $scope.cards.active = null;
    $scope.cards = {};
    console.log("$scope.totaluser", $scope.totaluser)
    // User pagination end and reload 1st page
    if($scope.totaluserMin <= 10){
      $scope.page = 1;
       //$cordovaToast.showLongBottom('Tap to refresh!');
    }else{
       $scope.page++
       $scope.totaluserMin =  $scope.totaluser - 10;
    }

    $scope.getUserlist();
   
    
  }

   $scope.$on('removeCard', function(event, element, card) {
   
    var discarded = $scope.cards.master.splice($scope.cards.master.indexOf(card), 1);
    $scope.cards.discards.push(discarded);
     if($scope.cards.master == 0 ){
           $cordovaToast.showLongBottom('Tap to refresh!');
      }
     
  });

 


  $scope.$on('likecard', function(event, element, card) {
     // console.log(card.userid)

        Profile.userlike($scope.token, card.userid).then(function(response){

         // console.log(response)
       
       if(response.data.success == true){
         $cordovaToast.showLongBottom('Interest sent');
       }
        
      })

        //var card = $scope.cards.active[index];
     // $scope.cards.liked.push(card);
    //console.log('RIGHT SWIPE');
  });

    $scope.$on('addcard', function(event, element, card) {

      console.log("card.userid", card.userid,  "$scope.loginuserId",  $scope.loginuserId)
      
      Profile.add_Connection($scope.token, $scope.loginuserId, card.userid).then(function(response){
        console.log(response)
       if(response.data.success == true){
         $cordovaToast.showLongBottom('Request sent successfully');
       }else{
         console.log(response.data.message);
       }
        
      })

     
      // var card = $scope.cards.active[index];
      // $scope.cards.liked.push(card);
    //console.log('RIGHT SWIPE');
  });


  $scope.cardSwipedLeft = function(index,card) {
     console.log($scope.cards)

    // var card = $scope.cards.active[index];
    // $scope.cards.disliked.push(card);

  // console.log("index : ", index, 'LEFT SWIPE');

    // if($scope.cards.master == 0 ){
    //        $cordovaToast.showLongBottom('Tap to refresh!');
    //   }

  };

  $scope.cardSwipedRight = function(index,card) {

      // $scope.cardTypes.splice(index, 1);
      // var card = $scope.cards.active[index];
      //  $scope.cards.liked.push(card);

      Profile.userlike($scope.token, card).then(function(response){
       if(response.data.success == true){
         $cordovaToast.showLongBottom('Interest sent');
       }
         
      })

         //   if($scope.cards.master == 0 ){
         //   $cordovaToast.showLongBottom('Tap to refresh!');
         // }

     console.log("call right")

   //console.log("index : ", index, 'right SWIPE');
  };

  //Get User LIST and card swipe

     
   //GO USER DETAILS PAGE
   $scope.viewuserDetails = function(userid){
      $state.go('app.profile_details', { "userid": userid});
   }




});
