

app.controller('messagedetailsCtrl', function($scope, $ionicScrollDelegate, $cordovaToast, $ionicModal, message, $timeout,$ionicSideMenuDelegate,$state, $stateParams) {

  //SHOW_HEADER
     $scope.$on("$ionicView.beforeEnter", function(event, data){

   $timeout(function() {
    $ionicSideMenuDelegate.canDragContent(false);        
          $scope.showHeader();
    },10);

  // $scope.messageList();
})
 // USER DETAILS
  $scope.token = localStorage.getItem("token");
  $scope.loginuserId = localStorage.getItem("loginuserId");
  
  $scope.page = 1;

///MESSEGE SCROLL CONTROLL 


    $timeout(function() { 
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom();               
     }, 100);


///MESSEGE MODAL 

    $ionicModal.fromTemplateUrl('templates/message_modal.html', {
        scope: $scope,
        animation: 'slide-in-up',
        }).then(function(modal) {
        $scope.modal = modal;
    });

    $scope.modalhide = function(){
       $scope.modal.hide();
  
    }

    $scope.mesegemodal = function(){
        $scope.modal.show();
        $scope.convId = "";
        console.log($scope.convId);
    }
  


  $scope.moveItem = function(item, fromIndex, toIndex) {
    $scope.items.splice(fromIndex, 1);
    $scope.items.splice(toIndex, 0, item);
  };
  
  $scope.onItemDelete = function(item) {
    $scope.items.splice($scope.items.indexOf(item), 1);
  };
  


  ////MESSAGE LIST///////////
  $scope.messagedata = [];

  $scope.messageList = function(){
      $scope.show();
      message.message_list($scope.token,$scope.page).then(function(response){
      $scope.hide();
      console.log(response);
        if(response.data.data.length == 0){
            $scope.infiniteScrollActive = false;
            $cordovaToast.showLongBottom("No messages"); 
        }else{

            for(var i=0;i<response.data.data.length;i++){
                $scope.messagedata.push(response.data.data[i]);
           }
        }
         
    })
  }


////LOAD MORE LIST

  $scope.infiniteScrollActive = true;
  $scope.loadMore = function() {
    $scope.infiniteScrollActive = false;
    $scope.page++
    $scope.messageList();
    $scope.$broadcast('scroll.infiniteScrollComplete');
  }


  $scope.groupMemberSearchClose = true;

  $scope.autoUsersearch = function(name){
     $scope.show();
     message.autoSerachUser($scope.token,name).then(function(response){
      $scope.hide();
      $scope.userlist = response.data.data;
      console.log("list =>", $scope.userlist);
      if($scope.userlist.length == 0){
        $cordovaToast.showLongBottom("Nobody in your connection!"); 
      }
    })
  }
  

    $scope.memberListFullData = [];
    $scope.messuserid = [];
    
    //adding members
    $scope.addMember = function(member){
      if($scope.messuserid.indexOf(member.userid) == -1){
        $scope.memberListFullData.push(member);
        $scope.messuserid.push(member.userid);
        $scope.userlist = [];
      }else{
        $cordovaToast.showLongBottom("Already added!");      
      }
    }
        
  //removing member from members array
  $scope.removeMember = function(memberData,memberId){
      //getting the data index
      var memberIndex = $scope.memberListFullData.indexOf(memberData);
      $scope.memberListFullData.splice(memberIndex, 1);

  }


  ////MESSAGE SEND///////////

  $scope.text = {};
   $scope.allmessages = [];   

  $scope.send_message = function(conv){ 

    if($scope.messuserid.length == 0){
       $cordovaToast.showLongBottom("Please add some Receiver.");       
    }else if($scope.text.message == "" || $scope.text.message == null || $scope.text.message == undefined){
       $cordovaToast.showLongBottom("Please write something in message."); 
    }else{
        $scope.show();
        message.send_message($scope.token, $scope.text.message, $scope.messuserid, $stateParams.obj).then(function(response){ 
          console.log("Sent msg", response)
            $scope.hide();
            if(response.data.success == true ){
              var allmessage = {};
               // $cordovaToast.showLongBottom("Message Sent");   
                 $scope.readConversation();     
                 $scope.allmessages.push(allmessage);      
                //$state.go('app.conversation_screen', {obj: localStorage.getItem("conv")}, {reload: true});
                $scope.modalhide();
                $scope.memberListFullData = [];
                $scope.messuserid = [];
                $scope.userlist = "";
                $scope.text = {};
                $scope.searchname = ""; 
            }else{
                $cordovaToast.showLongBottom(response.data.message);
            }
            
        })
    }
    
  }
  

  
  // MESSAGE REPLY////////
  
  $scope.replyMessage = function(convId){
      $scope.convId = convId;
      $state.go('app.conversation_screen', {obj: convId});
  }
  
  $scope.readConversation = function(){
      $scope.show();
      var userid = localStorage.getItem("loginuserId");
      message.conversationList($scope.token, $stateParams.obj,$scope.page).then(function(response){
        console.log("totalres:", response)
          $scope.allmessages = []; 
           $scope.servermsg = [];  

           if(response.data.data.length == 0){
               $scope.infiniteScrollActive = false;
            }

          for(var i=0;i<response.data.data.length;i++){
                $scope.servermsg.push(response.data.data[i]);
           }


          angular.forEach($scope.servermsg, function (res, i) {
                var allmessage = {};
                allmessage.direction = "";
                allmessage.name = res.From.name;

                allmessage.message = res.content;
                allmessage.id = res.conversationId;
                allmessage.imageURI = res.From.profile_pic;
                allmessage.date = res.createdAt;
                if(res.From.userid == userid){
                    allmessage.direction = "right";
                    allmessage.userid = res.From.userid;
                    $scope.messuserid = res.To.userid;
                    $scope.user_prof_pic = res.From.profile_pic;
                    $scope.user_name = res.From.name;
                }else{
                    allmessage.direction = "left";
                    allmessage.userid = res.From.userid;
                    $scope.messuserid = res.From.userid;
                    $scope.user_prof_pic = res.To.profile_pic;
                    $scope.user_name = res.To.name;
                }
                $scope.allmessages.push(allmessage);  
                console.log("Allmsg", $scope.allmessages) 
                    $timeout(function() { 
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom();               
      }, 100);

          });    
                
          $scope.hide();
          
          
      })
  }

///////////////LOAD MORE




  $scope.default = function(){
    if($stateParams.obj == "" || $stateParams.obj == "null" || $stateParams.obj == null){
     console.log($stateParams.obj, "true");

    }else{
      console.log($stateParams.obj, "fa");

      $scope.infiniteScrollActive = true;
      $scope.loadMore = function() {
        $scope.infiniteScrollActive = false;
        $scope.page++
        $scope.readConversation();
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }

    }
  };

  $scope.default();
  
  
  
  ////MESSAGE DELETE///////
  

  $scope.delete_conversation = function(id){
     //console.log(id);

      message.delete_message($scope.token, id).then(function(response){
        console.log(response);
         $scope.messageList();
      })
  }
  
    //GO OTHER PROFILE
   $scope.viewuserDetails = function(id){
    console.log("userid:", id)
    if(id == $scope.loginuserId){
       $state.go('app.edit_profile');
    }else{
       $state.go('app.profile_details', { "userid": id});
    }
   }


});

