
  //FOR CHAT SERVER DETAILS//



//var SERVER = "avijit";
// app.constant('XMPP', (function(){
//     //var SERVER = "avijit";
//     var SERVER = "192.168.1.71";
//     return {
//         BOSH_SERVICE: "http://"+SERVER+":7070/http-bind",
//         API_BASE: "http://"+SERVER+":9090/plugins/restapi/v1/users/",
//         //BOSH_SERVICE: "http://192.168.1.71:7070/http-bind",
//         DOMAIN: "avijit",
//         API_BASE: "http://" + SERVER + ':3000/api/'
//     }
// })());



app.factory('Chats', ['sharedConn', '$state', '$rootScope', 'XMPP', function(sharedConn, $state, $rootScope, XMPP){
           
            var connection = sharedConn.getConnectionObj();            
            var oChats = {};             
            oChats.rosters = [];            
            
            
            function onReceiveRosterIQ (iq){
                console.log("onReceiveRosterIQ > iq : ", iq);
                if(!iq || iq.length == 0)
                    return;
                
                //jquery load data after loading the page.This function updates data after jQuery loading
                $rootScope.$apply(function(){
                    
                     /*
                    Basically $(iq) is an xml response.
                    find("item") will return the array of <item subscription="value" />
                    each(	function(){}  is used to loop through all items

                    */
                   
                    
                    $(iq).find('item').each(function(){
                        if ($(this).attr("subscription") == "from" || $(this).attr("subscription") == "to" || $(this).attr("subscription") == "both") {
                            oChats.rosters.push({
                                id: $(this).attr("jid"),
                                name: $(this).attr("name") || $(this).attr("jid"),
                                lastText: 'Available to Chat',
                                face: 'img/ionic.png'
                            });
                        }
                        // Waiting for the Client 2 to accept the request
                        else if (($(this).attr("subscription") == "none") && ($(this).attr("ask") == "subscribe")) {
                            oChats.rosters.push({
                                id: $(this).attr("jid"),
                                name: $(this).attr("name") || $(this).attr("jid"),
                                lastText: "Waiting to accept",
                                face: "img/ionic.png"
                            });
                        }
                        else if ($(this).attr("subscription") == "none") {
                            console.log("none : ", $(this).attr("jid"));
                            var jid = Strophe.getBareJidFromJid($(this).attr("jid"));
                            
                            oChats.removeRoster(oChats.getRosterByJID(jid), false);
                            //console.log("roster : ", roster);
                        }
                    });
                    
                    //console.log("onReceiveRosterIQ > oChats.roster: ", oChats.rosters);
                });
            };      
            
            
            function onReceivePresence (presence){
                console.log("onReceivePresence > presence : ", presence);
                var presence_type = $(presence).attr('type'); // unavailable, subscribed, etc...
                var from_jid = $(presence).attr('from'); // the jabber_id of the contact
                if (presence_type != 'error' && typeof(presence_type) != "undefined") {
                    
                    var from = Strophe.getBareJidFromJid(from_jid);
                
                    $rootScope.$apply(function(){
                        
                        //if(oChats.rosters.length > 0){
                        oChats.rosters.forEach(function(elm, ind){
                            //console.log("elm.id : ", elm.id, " | from : ", from);
                            if(elm.id == from){
                                if (presence_type === 'unavailable') {
                                    console.log("offline"); //alert('offline');
                                    oChats.rosters[ind].lastText = "Offline";
                                } 
                                else if (presence_type == 'subscribed'){
                                    console.log("subscribed"); //alert('subscribed');
                                    oChats.rosters[ind].lastText = "Available to chat";
                                }
                                else if (presence_type == 'unsubscribed'){
                                    //oChats.rosters.splice(ind, 1)
                                    console.log("unsubscribed"); //alert('subscribed');
                                    oChats.rosters[ind].lastText = "Request declined";
                                }
                                else if (presence_type == 'unsubscribe'){
                                    //oChats.rosters.splice(ind, 1)
                                    console.log("unsubscribe"); //alert('subscribed');
                                    oChats.rosters[ind].lastText = "Not available";
                                    oChats.removeRoster(oChats.rosters[ind], false)
                                }
                                else {
                                    var show = $(presence).find("show").text(); // this is what gives away, dnd, etc.
                                    if (show === 'chat' || show === '') {
                                        console.log("online"); //alert('online');
                                        oChats.rosters[ind].lastText = "Online";
                                    } else {
                                        console.log("etc");//alert('etc');
                                        oChats.rosters[ind].lastText = "etc";
                                    }
                                }
                            }
                        });
                    });
                }
                return true;
            };
            
            
            var loadRoster = function(){
                //console.log("loadRoster called");
                var iq = $iq({type: 'get'}).c('query', {xmlns: 'jabber:iq:roster'});
                //On recieve roster iq
                connection.sendIQ(iq, onReceiveRosterIQ);
                
                // set up presence handler and send initial presence
                connection.addHandler(onReceivePresence, null, "presence");
                
                connection.send($pres());
                
                connection.addHandler(onReceiveUpdateRosterIQ, "jabber:iq:roster", "iq", "set");
                
                console.log("loadRoster > oChats.roster : ", oChats.rosters);
                
                return oChats.rosters;
                
            };
            
            var onReceiveUpdateRosterIQ = function(iq){                
                console.log("onReceiveUpdateRosterIQ > iq: ", iq);
                
                if(!iq || iq.length == 0)
                    return;
                
                $rootScope.$apply(function(){
                    
                    $(iq).find("item").each(function(ind, elm){
                        
                        //console.log("elm "+ind+": ", elm);
                        
                        if ($(this).attr("subscription") == "from") {
                            oChats.rosters.push({
                                id: $(this).attr("jid"),
                                name: $(this).attr("name") || $(this).attr("jid"),
                                lastText: "Available to chat",
                                face: "img/ionic.png"
                            });
                        }
                        // Waiting for the Client 2 to accept the request
                        else if (($(this).attr("subscription") == "none") && ($(this).attr("ask") == "subscribe")) {
                            oChats.rosters.push({
                                id: $(this).attr("jid"),
                                name: $(this).attr("name") || $(this).attr("jid"),
                                lastText: "Waiting to accept",
                                face: "img/ionic.png"
                            });
                        }

                        //roster update via Client 2 deleting the roster contact
                        else if ($(this).attr("subscription") == "none") {
                            console.log("none : ", $(this).attr("jid"));
                            var jid = Strophe.getBareJidFromJid($(this).attr("jid"));
                            
                            oChats.removeRoster(oChats.getRosterByJID(jid), false);
                            //console.log("roster : ", roster);
                        }

                        //console.log("oChats.rosters : ", oChats.rosters);
                    });
                    
                    
                    //Reloads the page
                    $state.go('tabsController.contacts', {}, {location: "replace", reload: true});
                });
                
                
            };
            
            oChats.allRoster = function(){
                loadRoster();
                return oChats.rosters
            };
            
            oChats.getRosterByJID = function(jid){
                for (var i = 0; i < oChats.rosters.length; i++){
                    if(oChats.rosters[i].id == jid){
                        return oChats.rosters[i];
                    }
                }
            };
            
            oChats.removeRoster = function(chat, send_pres){
                console.log("removeRoster > ", chat);                
                oChats.rosters.splice(oChats.rosters.indexOf(chat), 1);
                if(send_pres)
                    connection.send($pres({to : chat.id, type: 'unsubscribe'}));
            };
            
            oChats.addNewRosterContact = function(to_id){
                to_id = to_id + '@' + XMPP.DOMAIN;
                connection.send($pres({to : to_id, type: 'subscribe'}));   
                connection.send($pres());
            };
            
            
            
            return oChats;
        }]);