app.controller('ChatCtrl', function($scope,  $rootScope, $timeout, $ionicModal, $cordovaToast, connnection, $state) {
    
 
    
  $scope.$on("$ionicView.beforeEnter", function(event, data){
       $scope.get_connectionList();
       $scope.closeSebmodal();
  })


   $scope.loginuserId = localStorage.getItem("loginuserId");

   $scope.quickbloxid = [];

   $scope.page = 1;


/////////GET CONNECTION LIST///////////////

    $scope.get_connectionList = function(){
      $scope.show();
      connnection.get_connection_list($scope.token).then(function(response){
      console.log("connectlist:", response);
      $scope.hide();

       if(response.data.data.length == 0){
          $cordovaToast.showLongBottom('No connection yet!');
        }else{

          $rootScope.connction_list = [];
          $scope.connnectionUser = response.data.data;
          for(var i =0; i<$scope.connnectionUser.length; i++){
            $rootScope.connction_list.push($scope.connnectionUser[i]);

            if(!$scope.connnectionUser[i].quickblox_userid){
              $scope.quickbloxid.push(1234);
            }else{
              $scope.quickbloxid.push(JSON.parse($scope.connnectionUser[i].quickblox_userid));
            }
            
          }

          $scope.getChatUsers();
   
        }

   
      })

 
     

      

    }

    ///GET CHAT USERS//////////////////

    $scope.bofuser = [];
    var usersCount = 0;

  $scope.getChatUsers = function(page_number){

    console.log("$scope.page", page_number);


    $scope.show();
 

    var params = { page: $scope.page, per_page: '10', filter: { field: 'id', param: 'in', value: $scope.quickbloxid }};

    QB.users.listUsers(params, function(err, result){
       $scope.hide();
      if (result) {

         console.log("result= >", result);
        usersCount += result.items.length;

          console.log("result.total_entries= >", result.total_entries, "result.usersCount= >", usersCount);

          if(result.total_entries > usersCount){
               $scope.getChatUsers($scope.page++);
          }



        $rootScope.allusers = result.items;

          for(i in $rootScope.connction_list){
              
            var email = $scope.connction_list[i].email;
            var userid = $scope.connction_list[i].userid;
            var firstname = $scope.connction_list[i].firstname;
            var profile_pic = $scope.connction_list[i].profile_pic;

            for(i in $rootScope.allusers){
               // console.log("email = >", email, "serveremail", $rootScope.allusers[i].user.email)
                if(email == $rootScope.allusers[i].user.email){

                      var currentTimestamp = Math.floor(Date.now() / 1000);

                      var userLastRequestAtTimestamp = Math.floor(new Date($rootScope.allusers[i].user.last_request_at) / 1000);

                      console.log("currentTimestamp", currentTimestamp, "userLastRequestAtTimestamp", userLastRequestAtTimestamp)

                      // if user didn't do anything last 5 minutes (5*60 seconds)    
                      if((currentTimestamp - userLastRequestAtTimestamp) > 5*60){ 

                           $scope.bofuser.push({"chatid":$rootScope.allusers[i].user.id, "userid" : userid, "online": "offline", "firstname" : firstname, "profile_pic" : profile_pic});
                      }else{
                         $scope.bofuser.push({"chatid":$rootScope.allusers[i].user.id, "userid" : userid, "online": "online", "firstname" : firstname, "profile_pic" : profile_pic});
                      }
                }
              }

             
          }

        
       console.log("bofuser = >", $scope.bofuser)

     

      } else {
        // error
      }
    });


}




  /////////--------CHAT MODULE------///////////////

    $scope.chatD = function(userid, chatid){
         console.log(userid, chatid);
        $state.go('app.chatDetails', {"userid": userid, "chatid": chatid});
    };

    $scope.videochat = function(userid){
        console.log("chaid", userid);
        $state.go('app.videochat', { "userid": userid});
    };


   //GO OTHER PROFILE
   $scope.viewuserDetails = function(id){
    console.log("userid:", id)
    if(id == $scope.loginuserId){
       $state.go('app.edit_profile');
    }else{
       $state.go('app.profile_details', { "userid": id});
    }
   }


/////Oline of line user


});