

app.controller('connectionCtrl', function($scope, $ionicModal, $cordovaToast, connnection, $timeout,$ionicSideMenuDelegate,$state,$stateParams, message) {

  //SHOW_HEADER
  $scope.$on("$ionicView.beforeEnter", function(event, data){

    $timeout(function() {
      $ionicSideMenuDelegate.canDragContent(false);

      $scope.showHeader();
    },10);

       $scope.get_req_List();

  })

 // USER DETAILS
  $scope.token = localStorage.getItem("token");
  $scope.loginuserId = localStorage.getItem("loginuserId");


 /// GET CONNECTION LIST

   $scope.connction_list = [];

    $scope.get_connectionList = function(){
      $scope.show();
      connnection.get_connection_list($scope.token).then(function(response){
      // console.log(response);
      $scope.hide();
       if(response.data.data.length == 0){
          $cordovaToast.showLongBottom('No connection yet!');
        }
        $scope.connction_list = [];
        $scope.connnectionUser = response.data.data;
            var connection_data = [];
            for(var i =0; i<$scope.connnectionUser.length; i++){
              connection_data.push($scope.connnectionUser[i]);
            }
            var i,j,temparray,chunk = 2;

            for (i=0,j=connection_data.length; i<j; i+=chunk) {
            temparray = connection_data.slice(i,i+chunk);
              $scope.connction_list.push(temparray);
            }

          //  console.log($scope.connction_list);
      })
    }

 /// GET REQUEST LIST

   $scope.request_list = [];
    $scope.get_req_List = function(){
      $scope.show();
      connnection.get_req_list($scope.token).then(function(response){
      // console.log(response);
        $scope.hide();
        if(response.data.data.length == 0){
          $cordovaToast.showLongBottom('No body send request yet!');
        }
        $scope.request_list = [];
        $scope.connnectionUser = response.data.data;
            var connection_data = [];
            for(var i =0; i<$scope.connnectionUser.length; i++){
              connection_data.push($scope.connnectionUser[i]);
            }
            var i,j,temparray,chunk = 2;

            for (i=0,j=connection_data.length; i<j; i+=chunk) {
            temparray = connection_data.slice(i,i+chunk);
              $scope.request_list.push(temparray);
            }
            //console.log($scope.request_list);
      })
    }

   //CONNECTION REQ RESPONSE

    $scope.connection_req_response = function(index, id, responseuser){
        $scope.show();

      connnection.connection_req_res($scope.token, id, responseuser).then(function(response){
          $scope.hide();
        if(response.data.success == true){
           $scope.request_list.splice(index);

           if(responseuser == 'A'){
              $scope.currentTab = 'two.tpl.html';
              $scope.get_connectionList();
           }
        }
        console.log($scope.request_list);
      })

    }


   //GO USER DETAILS PAGE
   $scope.viewuserDetails = function(userid){
    console.log(userid)
      $state.go('app.profile_details', { "userid": userid});
   }


  ///INTEREST MEETING YOU ///////

  $scope.interest_meet_you = function(userid){
       connnection.interest_meet_invite($scope.token,  userid).then(function(response){
        console.log(response)
       if(response.data.success == true){
         $cordovaToast.showLongBottom('Request sent successfully');
       }else{
         $cordovaToast.showLongBottom(response.data.message);
       }
        
      })
  }
  
  $ionicModal.fromTemplateUrl('templates/message_modal.html', {
        scope: $scope,
        animation: 'slide-in-up',
        }).then(function(modal) {
        $scope.modal = modal;
    });
    
    $scope.messuserid = [];
  
   $scope.mesegemodal = function(name){        
        $scope.modal.show();
        $scope.show();
        $scope.usercount = "single";
        message.autoSerachUser($scope.token,name).then(function(response){
            $scope.memberListFullData = [];
            angular.forEach(response.data.data, function (res, i) {
                if(res.firstname == name){
                    $scope.memberListFullData.push(res);
                    $scope.messuserid.push($scope.memberListFullData[0].userid);
                }            
            });
            $scope.hide();
        })
   }
   
   $scope.text = {};

  $scope.send_message = function(){   
    if(!$scope.text.message)  {
      $cordovaToast.showLongBottom("Please write something in message");
    }else{
      $scope.show();
      message.send_message($scope.token, $scope.text.message, $scope.messuserid).then(function(response){ 
          $scope.hide();
          if(response.data.success == true ){
              $cordovaToast.showLongBottom("Message Sent");            
              //$state.go('app.conversation_screen', {obj: localStorage.getItem("conv")}, {reload: true});
              $scope.modal.hide();
              $scope.memberListFullData = [];
              $scope.messuserid = [];        
              $scope.text = {};  
          }else{
              $cordovaToast.showLongBottom(response.data.message);
          }        
                
   
      })

    } 
  }




//Tab-----//
$scope.tabs = [{
  title: 'Request',
  url: 'one.tpl.html'
}, {
  title: 'Connections',
  url: 'two.tpl.html'
}];

$scope.currentTab = 'one.tpl.html';

$scope.onClickTab = function (tab) {
  console.log(tab);
  if(tab.title == 'Connections'){
    $scope.get_connectionList();
  }else{
     $scope.get_req_List();
  }
  $scope.currentTab = tab.url;
}
$scope.isActiveTab = function(tabUrl) {
  return tabUrl == $scope.currentTab;
}




});

