


//var SERVER = "avijit";
app.constant('XMPP', (function(){
    //var SERVER = "avijit";
    var SERVER = "192.168.1.71";
    return {
        BOSH_SERVICE: "http://"+SERVER+":7070/http-bind",
        API_BASE: "http://"+SERVER+":9090/plugins/restapi/v1/users/",
        //BOSH_SERVICE: "http://192.168.1.71:7070/http-bind",
        DOMAIN: "avijit",
        API_BASE: "http://" + SERVER + ':3000/api/'
    }
})());


 app.factory('sharedConn', ['XMPP', '$state', '$rootScope', '$ionicPopup', function(XMPP, $state, $rootScope, $ionicPopup){
            var oSharedConn = {};
            
            oSharedConn.BOSH_SERVICE = XMPP.BOSH_SERVICE;
            oSharedConn.connection = null;
            oSharedConn.loggedIn = false;
            
            oSharedConn.register = function(username,password, name, email){
                console.log(username)
                oSharedConn.connection = new Strophe.Connection(oSharedConn.BOSH_SERVICE);
                
                var registerCallBack = function (status) {
                    if (status === Strophe.Status.REGISTER) {
                        // fill out the fields
                        oSharedConn.connection.register.fields.username = username;
                        oSharedConn.connection.register.fields.password = password;
                        oSharedConn.connection.register.fields.name = name;
                        oSharedConn.connection.register.fields.email = email;
                        // calling submit will continue the registration process
                        oSharedConn.connection.register.submit();
                    } else if (status === Strophe.Status.REGISTERED) {
                        console.log("registered!");
                        // calling login will authenticate the registered JID.
                        console.log("calling login will authenticate the registered JID.");
                        oSharedConn.connection.authenticate();
                    } else if (status === Strophe.Status.CONFLICT) {
                        console.log("Contact already existed!");
                    } else if (status === Strophe.Status.NOTACCEPTABLE) {
                        console.log("Registration form not properly filled out.")
                    } else if (status === Strophe.Status.REGIFAIL) {
                        console.log("The Server does not support In-Band Registration")
                    } else if (status === Strophe.Status.CONNECTED) {
                        // do something after successful authentication
                        console.log("do something after successful authentication");
                        $state.go('tabsController.contacts', {}, {location: "replace", reload: true});
                    } else {
                        // Do other stuff
                    }
                };
                
                oSharedConn.connection.register.connect(XMPP.DOMAIN, registerCallBack, 60, 1);
            };
            
            oSharedConn.login = function(user, pass){

                oSharedConn.connection = new Strophe.Connection(oSharedConn.BOSH_SERVICE, {'keepalive': true});
                console.log(user + '@' + XMPP.DOMAIN, pass);
                oSharedConn.connection.connect(user + '@' + XMPP.DOMAIN, pass, oSharedConn.onConnect);
            };
            
            oSharedConn.logout = function(){
                console.log("logging out...");
                oSharedConn.connection.options.sync = true;
                oSharedConn.connection.flush();
                oSharedConn.connection.disconnect();
            };
            
            //On connect XMPP
            oSharedConn.onConnect = function(status){
                if (status == Strophe.Status.CONNECTING) {
                    console.log('CONNECTING > Strophe is connecting.');
                } else if (status == Strophe.Status.CONNFAIL) {
                    console.log('CONNFAIL > Strophe failed to connect.');
                } else if (status == Strophe.Status.DISCONNECTING) {
                    console.log('DISCONNECTING > Strophe is disconnecting.');
                } else if (status == Strophe.Status.DISCONNECTED) {
                    console.log('DISCONNECTED > Strophe is disconnected.');
                    $state.go('login', {location: "replace", reload: true});
                } else if(status == Strophe.Status.AUTHFAIL){
                    console.log("Authentication failed");
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Authentication failed'
                    });                    
                } else if (status == Strophe.Status.CONNECTED) {
                    console.log('CONNECTED > Strophe is connected.');
                    oSharedConn.connection.addHandler(oSharedConn.onMessage, null, 'message', null, null, null);
                    oSharedConn.connection.send($pres().tree());
                    oSharedConn.loggedIn = true;
                    
                    oSharedConn.connection.addHandler(oSharedConn.onSubscriptionRequest, null, "presence", "subscribe");
                    
                    $state.go("app.home_screen", {}, {location: "replace", reload: true})
                     //$state.go('');
                }
            };
            
            //When a new message is recieved
            oSharedConn.onMessage = function(msg){
                $rootScope.$broadcast('messageReceivedBroadcast', msg);
                return true;
            };
                       
            oSharedConn.onSubscriptionRequest = function(stanza){
                console.log("onSubscriptionRequest > stanza : ", stanza);            
                if(stanza.getAttribute("type") == "subscribe" && !is_element_map(stanza.getAttribute("from"))){
                    $ionicPopup.confirm({
                        title: "Confirm friend request!",
                        template: " " + stanza.getAttribute("from") + " wants to be your friend..."
                    })
                    .then(function(res){
                        if(res){
                            oSharedConn.connection.send($pres({to: stanza.getAttribute("from"), type: "subscribed"}));
                            push_map(stanza.getAttribute("from"));
                        } else {
                            oSharedConn.connection.send($pres({to: stanza.getAttribute("from"), type: "unsubscribed"}));
                        }                        
                    });
                    return true;
                }
            };
            
            oSharedConn.getConnectionObj = function(){
                return oSharedConn.connection;
            };
            
            //============== Helper Functions ================//
            var accepted_map = {};
            var is_element_map = function(jid){
                if(jid in accepted_map)
                    return true;
                else 
                    return false;
            };
            
            var push_map = function (jid){
                accepted_map[jid] = true;
                console.log("accepted_map : ", accepted_map);
            };
            
            return oSharedConn;
        }]);