
var app = angular.module('starter.services',[]);


 //var BASE_URL = 'http://162.243.110.92:3433';

 //var BASE_URL = 'http://52.41.74.51:3433';
 console.log("BASE_URL", BASE_URL);

app.constant('shopSettings',{
   // payPalSandboxId : 'AdgNKYjOQTYUpX-5-c4gJEnN1ycfxSTVZ9gziu4vVNJPAKz9y4oWak14Um4wEy-DtNoT5DSyBL8VPMHU',
   // payPalProductionId :'AdgNKYjOQTYUpX-5-c4gJEnN1ycfxSTVZ9gziu4vVNJPAKz9y4oWak14Um4wEy-DtNoT5DSyBL8VPMHU',
   payPalSandboxId : 'AZ5Q63CgqEfdTDtyBINSnHSuB2rPIjJEruRYTeBVT_X-ojr1jdxzicvsmdrlXI8SZz4hN1yZiEo_i0Go',
   payPalProductionId :'AZ5Q63CgqEfdTDtyBINSnHSuB2rPIjJEruRYTeBVT_X-ojr1jdxzicvsmdrlXI8SZz4hN1yZiEo_i0Go',
   payPalEnv: 'PayPalEnvironmentProduction',   // for testing  production for production
   payPalShopName : 'Best of friend',
   // payPalMerchantPrivacyPolicyURL : 'url to policy',
   // payPalMerchantUserAgreementURL : ' url to user agreement '
});



app.constant('LOGIN', BASE_URL + '/api/login')
app.constant('LOGINFB', BASE_URL + '/api/fblogin')
app.constant('CHANGE_PASSWORD', BASE_URL + '/api/changePassword/')
app.constant('GET_COUNTRY', BASE_URL + '/api/countries')
app.constant('GET_COUNTRY_USA', BASE_URL + '/api/states_provinces/')
app.constant('GET_CITY', BASE_URL + '/api/cities/')
app.constant('REGISTER', BASE_URL + '/api/register')
app.constant('EMAILVERIFY', BASE_URL + '/api/verify-email')
app.constant('FBREGISTER', BASE_URL + '/api/socialmediaRegister')
app.constant('GOOGLELOGIN', BASE_URL + '/api/gplogin')
app.constant('FORGOTPASS', BASE_URL + '/api/forgot-pass')
app.constant('PROFILE_DETAILS', BASE_URL + '/api/profile_details/')
app.constant('UPDATE_PROFILE_DETAILS', BASE_URL + '/api/update-user/')
app.constant('USER_LIST', BASE_URL + '/api/userlist/')
app.constant('USER_SEARCH', BASE_URL + '/api/SearchUser/')
app.constant('PROFILE_VIEWER', BASE_URL + '/api/profile-viewer/')
app.constant('PROFILE_VIEWER_LIST', BASE_URL + '/api/profile-viewer-list/')
app.constant('ADD_CONNECTION', BASE_URL + '/api/addConnect/')
app.constant('LIKE_CONNECTION', BASE_URL + '/api/like/')
app.constant('REQUEST_LIST', BASE_URL + '/api/connection_request_list/')
app.constant('CONNECTION_LIST', BASE_URL + '/api/connection_list/')
app.constant('CONNECTION_REQ_RES', BASE_URL + '/api/respond_connection')
app.constant('INTEREST_MEET_INVITE', BASE_URL + '/api/interestinmeeting/')
app.constant('INTEREST_MEET_INVITE_LIST', BASE_URL + '/api/interest_list/')
app.constant('IMAGE_VIDEO_LIST', BASE_URL + '/api/getimagevideolist/')
app.constant('DELETE_MEDIA', BASE_URL + '/api/remove_media/')
app.constant('MESSAGE_LIST', BASE_URL + '/api/message_list/')
app.constant('MESSAGE_SEND', BASE_URL + '/api/send_message/')
app.constant('MESSAGE_DELETE', BASE_URL + '/api/conversation_delete/')
app.constant('USER_REPORT', BASE_URL + '/api/add_report/')
app.constant('BLOCK_USER', BASE_URL + '/api/blockunblock/')
app.constant('BLOCKED_LIST', BASE_URL + '/api/block_list')
app.constant('AUTO_USER_SEARCH', BASE_URL + '/api/find_user/')
app.constant('CONVERSATION_LIST', BASE_URL + '/api/conversation_list/')
app.constant('PAYPAL_PAYMENT_SAVE', BASE_URL + '/api/paymentSave')
app.constant('GET_PLAN', BASE_URL + '/api/subscription_plans/')
app.constant('NOTIFICATION', BASE_URL + '/api/notification_list/')
app.constant('GET_USER_ACTIVE_PLAN', BASE_URL + '/api/user_subscription/')
app.constant('TRNS_HISTORY', BASE_URL + '/api/transaction_history/')
app.constant('LIVE_CHAT_DETAILS', BASE_URL + '/api/chat_details/')

app.constant('CHATIDSAVE', BASE_URL + '/api/update-quickblox-userid')






app.service('Authorization', function($q, CHATIDSAVE,  $http, GET_COUNTRY_USA,  EMAILVERIFY, GET_COUNTRY, GET_CITY,  FORGOTPASS, GOOGLELOGIN, $ionicPopup, LOGIN,  REGISTER,LOGINFB, FBREGISTER){

	 return {
    // login
    login : function(email,pass){

        var device_token = localStorage.getItem("devicetoken");

        console.log(device_token);

         var defer = $q.defer();
        $http({
          method : 'POST',
          url : LOGIN,
          data : {email : email, password : pass, device_token: device_token},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          //console.log(response);
          defer.resolve(response);
        });

        return defer.promise;

    }, // end of login

      emailverify : function(email){
        var defer = $q.defer();
        $http({
          method : 'GET',
          url : EMAILVERIFY+'?email='+email,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          console.log(response);
          defer.resolve(response);
        });

        return defer.promise;

    }, // end of login
    
    

      forgot : function(email) {
      var defer = $q.defer();
      $http({
          method : 'POST',
          url : FORGOTPASS,
           data : {email  : email},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          defer.resolve(response);
        });

        return defer.promise;
    },  // end of  // Forgot

    register : function(obj) {
      var defer = $q.defer();
      $http({
          method : 'POST',
          url : REGISTER,
          data : obj,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          defer.resolve(response);
        });

        return defer.promise;
    },  // end of registration

     CHATIDREG : function(userid, chatid) {
      var defer = $q.defer();
      $http({
          method : 'POST',
          url : CHATIDSAVE,
          data : {quickblox_userid : chatid, _user: userid},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          defer.resolve(response);
        });

        return defer.promise;
    },  // end of registration

     fbregister : function(obj) {
      var defer = $q.defer();
      $http({
          method : 'POST',
          url : FBREGISTER,
          data : obj,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          defer.resolve(response);
        });

        return defer.promise;
    },  // end of registration

     getcountry : function(obj) {
      var defer = $q.defer();
      $http({
          method : 'GET',
          url : GET_COUNTRY,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          defer.resolve(response);
        });

        return defer.promise;
    },  // end of country list

     getUSAstate : function(obj) {
      var defer = $q.defer();
      $http({
          method : 'GET',
          url : GET_COUNTRY_USA,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          defer.resolve(response);
        });

        return defer.promise;
    },  // end of country list



     getcity : function(country) {
      var defer = $q.defer();
      $http({
          method : 'GET',
          url : GET_CITY+country,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          defer.resolve(response);
        });

        return defer.promise;
    },  // end of country list


 
    google_login : function(gpid) {
      var defer = $q.defer();

      var device_token = localStorage.getItem("devicetoken");

      $http({
          method : 'POST',
          url : GOOGLELOGIN,
          data : {gpid : gpid, device_token: device_token},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
          console.log(response);
          defer.resolve(response);
        });

        return defer.promise;

    },   // end of googlelogin

  };

});

app.service('Profile', function($q, PROFILE_VIEWER, CHANGE_PASSWORD, GET_USER_ACTIVE_PLAN, LIKE_CONNECTION, NOTIFICATION, ADD_CONNECTION, PROFILE_VIEWER_LIST,USER_LIST, $http, $ionicPopup, PROFILE_DETAILS, UPDATE_PROFILE_DETAILS, USER_SEARCH){

   return {
    // Get profile
    getProfiledetails : function(token, userid){

         var defer = $q.defer();
        $http({
          method : 'GET',
          url : PROFILE_DETAILS+userid+'?token='+ token, 
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    }, 
    // UpdateProfileDetails
      UpdateProfileDetails : function(obj,token) {
        console.log(obj);

        var currentDob =  obj.dob.toLocaleDateString();
        var changedate = currentDob.split('/');
        var updatedate = changedate[2]+'-'+changedate[1]+'-'+changedate[0];

        //console.log(updatedate);

      
      var defer = $q.defer();
      $http({
          method : 'PUT',
          url : UPDATE_PROFILE_DETAILS,
           data : {firstname:obj.firstname, city: obj.city, country: obj.country, bodytype:obj.bodytype.value,
          height: obj.frm_height.value, smoke:obj.smoke.value, userchild: obj.userchild.value, education:obj.education.value,
          religion: obj.religion.value, relationship: obj.relationship.value, dob: updatedate},
          headers: {'Content-Type' : 'application/json', "x-access-token" : token}
        }).then(function(response){
          defer.resolve(response);
        });

        return defer.promise;

    }, 

     getNotification : function(token, page){

           var defer = $q.defer();
            $http({
                method: 'GET',
                url : NOTIFICATION+'?token='+token+'&page='+page, 
                headers: {'Content-Type':'application/json'}
            }).then(function(response){
              //console.log(response);
                defer.resolve(response);
            });
            return defer.promise;
        },

    // Get User list
    getuserlist : function(token, page){

       var limit = 10;

        var defer = $q.defer();
        $http({
          method : 'GET',
          url : USER_LIST+'?token='+token+'&page='+page+'&limit='+limit, 
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

    // Vewi Oter Profile
    profileViewer : function(token, viewid){

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : PROFILE_VIEWER,
          data: {token: token, viewed: viewid},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

            // CHANGE PASSWORD
    changePassword : function(token, password){

        console.log(token);

         var defer = $q.defer();
        $http({
          method : 'POST',
          url : CHANGE_PASSWORD+'?token='+ token, 
          data: {password: password},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    }, 

    //        // CHANGE PASSWORD
    // change_CHAT_Password : function(user, password){

    //      var defer = $q.defer();
    //      $http({
    //         method: 'PUT',
    //         url: XMPP.change_pass+user,
    //         data:{name: "abcd"},
    //         header: {'Content-Type':'application/json', 'Authorization': 'Basic YWRtaW46MTIzNDU='}
    //         }).then(function(response){
    //           console.log("chat password", response);
    //         defer.resolve(response);
    //     });

    //     return defer.promise;

    // }, 

     // Get Profile view list
    profileViewerlist : function(token,page){

        var defer = $q.defer();
        $http({
          method : 'GET',
          url : PROFILE_VIEWER_LIST+'?token='+token+'&page='+page,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

    // ADD CONNECTION
    add_Connection : function(token,senderid, receiverid){

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : ADD_CONNECTION+'?token='+token,
          data: {sender:senderid, receiver:receiverid },
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

    // Like CONNECTION
    userlike : function(token,senderid){

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : LIKE_CONNECTION+'?token='+token,
          data: {userid:senderid },
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },
        // Search User list
    getusersearchlist : function(token, serarchdata){

      console.log(token)

       var limit = 10;
       var page = 1;

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : USER_SEARCH+'?token='+token+'&page='+page+'&limit='+limit,
          data: {from_age:serarchdata.from_age.value, to_age:serarchdata.to_age.value, bodytype:serarchdata.bodytype.value, distance:serarchdata.distance.value,
          userchild:serarchdata.userchild.value,education:serarchdata.education.value, name:'', country:'', city:'', frm_height:serarchdata.frm_height.value, to_height:serarchdata.to_height.value },
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

    ///GET USER ACTIVE PLAN INFO
        getactiveplan : function(token){

           var defer = $q.defer();
            $http({
                method: 'GET',
                url: GET_USER_ACTIVE_PLAN+'?token='+token,
                headers: {'Content-Type':'application/json'}
            }).then(function(response){
               //console.log(response);
                defer.resolve(response);
            });
            return defer.promise;
        }

  };

});

app.service('connnection', function($q, $http, IMAGE_VIDEO_LIST, DELETE_MEDIA, REQUEST_LIST, CONNECTION_LIST, CONNECTION_REQ_RES, INTEREST_MEET_INVITE, INTEREST_MEET_INVITE_LIST){
  return{

     // CONNECTION LIST
     get_connection_list : function(token){

        var defer = $q.defer();
        $http({
          method : 'GET',
          url : CONNECTION_LIST+'?token='+token,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },


     // CONNECTION REQUEST LIST
     get_req_list : function(token){

        var defer = $q.defer();
        $http({
          method : 'GET',
          url : REQUEST_LIST+'?token='+token,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

     // INTEREST MEET INVITE 
     interest_meet_invite : function(token, senderid){

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : INTEREST_MEET_INVITE+'?token='+token,
          data: {receiver: senderid},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },


   // INTEREST MEET LIST
     interest_meet_list : function(token){

        var defer = $q.defer();
        $http({
          method : 'GET',
          url : INTEREST_MEET_INVITE_LIST+'?token='+token,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

    // CONNECTION REQ RES
     connection_req_res : function(token, connectionid, responseUser){
        var defer = $q.defer();
        $http({
          method : 'PUT',
          url : CONNECTION_REQ_RES+'?token='+token,
          data: {connectionid: connectionid, response: responseUser},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },


     // Image-Video List 
     image_video_list : function(token,userid,type){

         console.log(userid);

        var defer = $q.defer();
        $http({
          method : 'GET',
          url : IMAGE_VIDEO_LIST+userid+'/'+'?type='+type+'&token='+token,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },


     // MEDIA DELETE
     media_delete : function(token, id){

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : DELETE_MEDIA+'?token='+token,
          data: {media_id: id},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    }



  }
});


app.service('message', function($q, $http,LIVE_CHAT_DETAILS,  MESSAGE_DELETE, PAYPAL_PAYMENT_SAVE, MESSAGE_LIST, MESSAGE_SEND, AUTO_USER_SEARCH, CONVERSATION_LIST){
  return{

     // MESSEGE LIST
     message_list : function(token,page){
        var defer = $q.defer();
        $http({
          method : 'GET',
          url : MESSAGE_LIST+'?token='+token+'&page='+page,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){           
            defer.resolve(response);
        });

        return defer.promise;

    },

    // LIVE CHAT DETAILS
     live_chatDetails : function(token, partner_id){
        var defer = $q.defer();
        $http({
          method : 'POST',
          url : LIVE_CHAT_DETAILS+'?token='+token,
           data:{partner_id: partner_id},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){           
            defer.resolve(response);
        });

        return defer.promise;

    },

    

     // MESSEGE SEND
     send_message : function(token, message, receiverid,conv_id){

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : MESSAGE_SEND+'?token='+token,
          data:{receiver: receiverid, message: message, conv_id: conv_id},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

    // MESSEGE DELETE
     delete_message : function(token, conv_id){
        var defer = $q.defer();
        $http({
          method : 'POST',
          url : MESSAGE_DELETE+'?token='+token,
          data:{conv_id: conv_id},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },



     // AUTO SEARCH USER
     autoSerachUser : function(token, name){

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : AUTO_USER_SEARCH+'?token='+token,
          data:{ name: name},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },
    
    
    // CONVERSATION LIST
    conversationList : function(token, convId, page){        
        var defer = $q.defer();       
        var limit = 5000;
        $http({
          method : 'GET',
          url : CONVERSATION_LIST+convId+'/?token='+token+'&page='+page+'&limit='+limit,          
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;
    },

  }
});

app.service('useraction', function($q, $http, TRNS_HISTORY,  GET_PLAN,  PAYPAL_PAYMENT_SAVE, USER_REPORT, BLOCK_USER, BLOCKED_LIST){
  return{

     // report user
     report_user : function(token, loginuser, reportuser, isssue, info){
        var defer = $q.defer();
        $http({
          method : 'POST',
          url : USER_REPORT+'?token='+token,
          data:{reportingAgainst: reportuser, reportedBy: loginuser, issue:isssue, description:info },
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

     // Block user
     block_user : function(token, loginuserid, blockuserid){

        var defer = $q.defer();
        $http({
          method : 'POST',
          url : BLOCK_USER+'?token='+token,
          data:{userid: loginuserid, friendid: blockuserid},
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

       // Block list
     blocked_userList : function(token){

        var defer = $q.defer();
        $http({
          method : 'GET',
          url : BLOCKED_LIST+'?token='+token,
          headers: {'Content-Type' : 'application/json'}
        }).then(function(response){
            defer.resolve(response);
        });

        return defer.promise;

    },

     paypal_sevice : function(token, userId, paymentid,planid){

           var defer = $q.defer();
            $http({
                method: 'POST',
                url: PAYPAL_PAYMENT_SAVE+'?token='+token,
                data: {userid:userId, paymentId:paymentid, planid:planid},
                headers: {'Content-Type':'application/json'}
            }).then(function(response){
               console.log(response);
                defer.resolve(response);
            });
            return defer.promise;
        },

        getplan : function(token){

           var defer = $q.defer();
            $http({
                method: 'GET',
                url: GET_PLAN+'?token='+token,
                headers: {'Content-Type':'application/json'}
            }).then(function(response){
               console.log(response);
                defer.resolve(response);
            });
            return defer.promise;
        },
          transHistory : function(token){
           var defer = $q.defer();
            $http({
                method: 'GET',
                url: TRNS_HISTORY+'?token='+token,
                headers: {'Content-Type':'application/json'}
            }).then(function(response){
               console.log(response);
                defer.resolve(response);
            });
            return defer.promise;
        }


  }
});

app.service('myService', function() {
 var savedData = null;
 function set(data) {
   savedData = data;
 }
 function get() {
  return savedData;
 }

 return {
  set: set,
  get: get
 }

});




app.service('UserService', function($http, LOGINFB) {
  // For the purpose of this example I will store user data on ionic local storage but you should save it on a database
  var setUser = function(user_data) {
    window.localStorage.starter_facebook_user = JSON.stringify(user_data);


  };

  var getUser = function(){
    return JSON.parse(window.localStorage.starter_facebook_user || '{}');
  };

  var authenticateFBUser = function(fbdata){
    var device_token = localStorage.getItem("devicetoken");
    return $http({
      method : 'POST',
      url : LOGINFB,
      data : {fbid : fbdata.userID, device_token: device_token},
      headers: {'Content-Type' : 'application/json'}
    });
  }

  return {
    getUser: getUser,
    setUser: setUser,
    authenticateFBUser: authenticateFBUser
  };
});

app.factory('PaypalService', ['$q', '$ionicPlatform', 'shopSettings', '$filter', '$timeout', function ($q, $ionicPlatform, shopSettings, $filter, $timeout) {

    var init_defer;
    /**
     * Service object
     * @type object
     */
    var service = {
        initPaymentUI: initPaymentUI,
        createPayment: createPayment,
        configuration: configuration,
        onPayPalMobileInit: onPayPalMobileInit,
        makePayment: makePayment
    };


    /**
     * @ngdoc method
     * @name initPaymentUI
     * @methodOf app.PaypalService
     * @description
     * Inits the payapl ui with certain envs. 
     *
     * 
     * @returns {object} Promise paypal ui init done
     */
    function initPaymentUI() {
        init_defer = $q.defer();
        $ionicPlatform.ready().then(function () {

            var clientIDs = {
                "PayPalEnvironmentProduction": shopSettings.payPalProductionId,
                "PayPalEnvironmentSandbox": shopSettings.payPalSandboxId
            };
            PayPalMobile.init(clientIDs, onPayPalMobileInit);
        });

        return init_defer.promise;

    }


    /**
     * @ngdoc method
     * @name createPayment
     * @methodOf app.PaypalService
     * @param {string|number} total total sum. Pattern 12.23
     * @param {string} name name of the item in paypal
     * @description
     * Creates a paypal payment object 
     *
     * 
     * @returns {object} PayPalPaymentObject
     */
    function createPayment(total, name) {

        // "Sale  == >  immediate payment
        // "Auth" for payment authorization only, to be captured separately at a later time.
        // "Order" for taking an order, with authorization and capture to be done separately at a later time.
        var payment = new PayPalPayment("" + total, "USD", "" + name, "Sale");
        return payment;
    }
    /**
     * @ngdoc method
     * @name configuration
     * @methodOf app.PaypalService
     * @description
     * Helper to create a paypal configuration object
     *
     * 
     * @returns {object} PayPal configuration
     */
    function configuration() {
        // for more options see `paypal-mobile-js-helper.js`
        var config = new PayPalConfiguration({merchantName: shopSettings.payPalShopName, merchantPrivacyPolicyURL: shopSettings.payPalMerchantPrivacyPolicyURL, merchantUserAgreementURL: shopSettings.payPalMerchantUserAgreementURL});
        return config;
    }

    function onPayPalMobileInit() {
        $ionicPlatform.ready().then(function () {
            // must be called
            // use PayPalEnvironmentNoNetwork mode to get look and feel of the flow
            PayPalMobile.prepareToRender(shopSettings.payPalEnv, configuration(), function () {

                $timeout(function () {
                    init_defer.resolve();
                });

            });
        });
    }

    /**
     * @ngdoc method
     * @name makePayment
     * @methodOf app.PaypalService
     * @param {string|number} total total sum. Pattern 12.23
     * @param {string} name name of the item in paypal
     * @description
     * Performs a paypal single payment 
     *
     * 
     * @returns {object} Promise gets resolved on successful payment, rejected on error 
     */
    function makePayment(total, name) {


        var defer = $q.defer();
        total = $filter('number')(total, 2);
        $ionicPlatform.ready().then(function () {
            PayPalMobile.renderSinglePaymentUI(createPayment(total, name), function (result) {
                $timeout(function () {
                    defer.resolve(result);
                });
            }, function (error) {
                $timeout(function () {
                    defer.reject(error);
                });
            });
        });

        return defer.promise;
    }

    return service;
}]);

